

<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>gwmat.general_utils &mdash; GWMAT: Gravitational Wave Microlensing Analysis Tools 1.0.0 documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=80d5e7a1" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=7ab3649f" />

  
      <script src="../../_static/jquery.js?v=5d32c60e"></script>
      <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
      <script src="../../_static/documentation_options.js?v=8d563738"></script>
      <script src="../../_static/doctools.js?v=9a2dae69"></script>
      <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            GWMAT: Gravitational Wave Microlensing Analysis Tools
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../gwmat.html">gwmat package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">GWMAT: Gravitational Wave Microlensing Analysis Tools</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../gwmat.html">gwmat</a></li>
      <li class="breadcrumb-item active">gwmat.general_utils</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for gwmat.general_utils</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">This module contains the class `GeneralUtils`, which provides some</span>
<span class="sd">useful utility functions.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;Anuj Mishra &lt;anuj.mishra@ligo.org&gt;&quot;</span><span class="p">]</span>

<span class="kn">import</span> <span class="nn">math</span>
<span class="kn">import</span> <span class="nn">collections</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>


<div class="viewcode-block" id="GeneralUtils">
<a class="viewcode-back" href="../../gwmat.html#gwmat.general_utils.GeneralUtils">[docs]</a>
<span class="k">class</span> <span class="nc">GeneralUtils</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Miscallaneous functions that can make your life simpler and effective.</span>

<span class="sd">    &quot;&quot;&quot;</span>

<div class="viewcode-block" id="GeneralUtils.print_dict">
<a class="viewcode-back" href="../../gwmat.html#gwmat.general_utils.GeneralUtils.print_dict">[docs]</a>
    <span class="k">def</span> <span class="nf">print_dict</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">a_dict</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Function to print a dictionary element by element.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">a_dict</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">key</span><span class="si">}</span><span class="s2"> : </span><span class="si">{</span><span class="nb">repr</span><span class="p">(</span><span class="n">value</span><span class="p">)</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span></div>


<div class="viewcode-block" id="GeneralUtils.distribute">
<a class="viewcode-back" href="../../gwmat.html#gwmat.general_utils.GeneralUtils.distribute">[docs]</a>
    <span class="k">def</span> <span class="nf">distribute</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">array</span><span class="p">,</span> <span class="n">rank</span><span class="p">,</span> <span class="n">ncpus</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Function to efficiently distribute an array/list among</span>
<span class="sd">        different processors.</span>
<span class="sd">        Useful for parallel computations, such as MPI.</span>
<span class="sd">        It maintains original order of the array while distributing.</span>
<span class="sd">        Caution: empty arrays can be checked using array.size == 0</span>
<span class="sd">        before doing any operation to avoid errors.</span>

<span class="sd">        Example</span>
<span class="sd">        -------</span>

<span class="sd">        .. code-block:: python</span>
<span class="sd">        </span>
<span class="sd">            # Example 1: Distributing the array among 3 ranks</span>
<span class="sd">            distribute(array=[1, 2, 3, 4, 5, 6, 7], rank=0, ncpus=3) </span>
<span class="sd">            # Output: [1, 2, 3]  # Elements for rank 0</span>
<span class="sd">        </span>
<span class="sd">            distribute(array=[1, 2, 3, 4, 5, 6, 7], rank=1, ncpus=3) </span>
<span class="sd">            # Output: [4, 5]     # Elements for rank 1</span>
<span class="sd">        </span>
<span class="sd">            distribute(array=[1, 2, 3, 4, 5, 6, 7], rank=2, ncpus=3) </span>
<span class="sd">            # Output: [6, 7]     # Elements for rank 2</span>
<span class="sd">        </span>
<span class="sd">        Each rank gets its assigned portion of the array, </span>
<span class="sd">        with excess elements allocated sequentially </span>
<span class="sd">        starting from `rank=0` up to `ncpus-1`.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        array : numpy.array or list</span>
<span class="sd">            Array to be distributed.</span>
<span class="sd">        rank : int</span>
<span class="sd">            Rank of the process. An integer between [0, ncpus-1].</span>
<span class="sd">        ncpus : int</span>
<span class="sd">            Total number of processors.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        numpy.array</span>
<span class="sd">            A segment of the provided array assigned to rank=rank.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">array</span><span class="p">)</span>
        <span class="n">array_len</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">array</span><span class="p">)</span>
        <span class="n">q</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">array_len</span> <span class="o">/</span> <span class="n">ncpus</span><span class="p">)</span>
        <span class="n">rem</span> <span class="o">=</span> <span class="n">array_len</span> <span class="o">-</span> <span class="n">q</span> <span class="o">*</span> <span class="n">ncpus</span>

        <span class="k">if</span> <span class="n">rank</span> <span class="o">&lt;</span> <span class="n">rem</span><span class="p">:</span>
            <span class="n">d_array</span> <span class="o">=</span> <span class="n">array</span><span class="p">[</span><span class="n">rank</span> <span class="o">*</span> <span class="p">(</span><span class="n">q</span> <span class="o">+</span> <span class="mi">1</span><span class="p">):</span> <span class="p">(</span><span class="n">rank</span> <span class="o">+</span> <span class="mi">1</span><span class="p">)</span> <span class="o">*</span> <span class="p">(</span><span class="n">q</span> <span class="o">+</span> <span class="mi">1</span><span class="p">)]</span>
        <span class="k">elif</span> <span class="n">rem</span> <span class="o">&lt;=</span> <span class="n">rank</span> <span class="o">&lt;=</span> <span class="n">ncpus</span> <span class="o">-</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">d_array</span> <span class="o">=</span> <span class="n">array</span><span class="p">[</span><span class="n">rank</span> <span class="o">*</span> <span class="n">q</span> <span class="o">+</span> <span class="n">rem</span><span class="p">:</span> <span class="p">(</span><span class="n">rank</span> <span class="o">+</span> <span class="mi">1</span><span class="p">)</span> <span class="o">*</span> <span class="n">q</span> <span class="o">+</span> <span class="n">rem</span><span class="p">]</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">d_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([])</span>
        <span class="k">return</span> <span class="n">d_array</span></div>


<div class="viewcode-block" id="GeneralUtils.find_nearest">
<a class="viewcode-back" href="../../gwmat.html#gwmat.general_utils.GeneralUtils.find_nearest">[docs]</a>
    <span class="k">def</span> <span class="nf">find_nearest</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">array</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns nearest element in an array to a given value.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        array : numpy.array/list</span>
<span class="sd">        value : value to search for</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        int</span>
<span class="sd">            index of the nearest element.</span>
<span class="sd">        float</span>
<span class="sd">            Neearest element found in the array.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">asarray</span><span class="p">(</span><span class="n">array</span><span class="p">)</span>
        <span class="n">idx</span> <span class="o">=</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">array</span> <span class="o">-</span> <span class="n">value</span><span class="p">))</span><span class="o">.</span><span class="n">argmin</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">idx</span><span class="p">,</span> <span class="n">array</span><span class="p">[</span><span class="n">idx</span><span class="p">]</span></div>


<div class="viewcode-block" id="GeneralUtils.is_num">
<a class="viewcode-back" href="../../gwmat.html#gwmat.general_utils.GeneralUtils.is_num">[docs]</a>
    <span class="k">def</span> <span class="nf">is_num</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Function to check whether an input is a number or not.</span>
<span class="sd">        There is scope of improving the function as it can sometimes</span>
<span class="sd">        give false positives.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        x : python object</span>
<span class="sd">            Object to check.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        Bool</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">):</span>
            <span class="c1"># to take care of cases where a scalar is defined as np.array(num)</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
                <span class="k">return</span> <span class="kc">False</span>
            <span class="k">except</span> <span class="ne">TypeError</span><span class="p">:</span>
                <span class="k">return</span> <span class="kc">True</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">is_list_type</span> <span class="o">=</span> <span class="nb">isinstance</span><span class="p">(</span>
                <span class="n">x</span><span class="p">,</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="nb">dict</span><span class="p">,</span> <span class="n">collections</span><span class="o">.</span><span class="n">abc</span><span class="o">.</span><span class="n">Sequence</span><span class="p">)</span>
            <span class="p">)</span>  <span class="c1"># [collections.abc.Sequence, np.ndarray, dict, np.nan])</span>
            <span class="k">if</span> <span class="n">is_list_type</span><span class="p">:</span>
                <span class="k">return</span> <span class="kc">False</span>
            <span class="k">if</span> <span class="n">math</span><span class="o">.</span><span class="n">isnan</span><span class="p">(</span><span class="n">x</span><span class="p">):</span>
                <span class="k">return</span> <span class="kc">False</span>
            <span class="k">return</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="p">(</span><span class="nb">float</span><span class="p">,</span> <span class="nb">int</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">floating</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">complexfloating</span><span class="p">))</span></div>


<div class="viewcode-block" id="GeneralUtils.str_num">
<a class="viewcode-back" href="../../gwmat.html#gwmat.general_utils.GeneralUtils.str_num">[docs]</a>
    <span class="k">def</span> <span class="nf">str_num</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">n</span><span class="p">,</span> <span class="n">r</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Function to covert an integer (n) to a string with</span>
<span class="sd">        specified number of digits (r).</span>
<span class="sd">        r &lt; n will be treated as n itself.</span>
<span class="sd">        r &gt; n will apply extra 0&#39;s in the beginning.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        n : int</span>
<span class="sd">            Integer object to convert.</span>
<span class="sd">        r : int</span>
<span class="sd">            Number of digits in the string.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        str</span>
<span class="sd">            String corresponding to the provided integer.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">i</span> <span class="o">=</span> <span class="mi">1</span>
        <span class="k">while</span> <span class="n">n</span> <span class="o">/</span> <span class="mi">10</span><span class="o">**</span><span class="n">i</span> <span class="o">&gt;=</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">i</span> <span class="o">+=</span> <span class="mi">1</span>
        <span class="k">return</span> <span class="s2">&quot;0&quot;</span> <span class="o">*</span> <span class="p">(</span><span class="n">r</span> <span class="o">-</span> <span class="n">i</span><span class="p">)</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">n</span><span class="p">)</span></div>


<div class="viewcode-block" id="GeneralUtils.str_float">
<a class="viewcode-back" href="../../gwmat.html#gwmat.general_utils.GeneralUtils.str_float">[docs]</a>
    <span class="k">def</span> <span class="nf">str_float</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">n</span><span class="p">,</span> <span class="n">r</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Function to covert a float (n) to a string</span>
<span class="sd">        up to `r` decimal places.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        n : float</span>
<span class="sd">            Float object to convert.</span>
<span class="sd">        r : int</span>
<span class="sd">            Number of decimal places to consider while conversion.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        str</span>
<span class="sd">            String corresponding to the provided float</span>
<span class="sd">            valid upto r decimal places.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">dec</span> <span class="o">=</span> <span class="nb">round</span><span class="p">(</span><span class="n">n</span> <span class="o">%</span> <span class="mi">1</span><span class="p">,</span> <span class="n">r</span><span class="p">)</span>
        <span class="n">str_dec</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">str_num</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="nb">round</span><span class="p">(</span><span class="mi">10</span><span class="o">**</span><span class="n">r</span> <span class="o">*</span> <span class="n">dec</span><span class="p">)),</span> <span class="n">r</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">dec</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">n</span> <span class="o">+=</span> <span class="mi">1</span>
            <span class="n">str_dec</span> <span class="o">=</span> <span class="n">str_dec</span><span class="p">[</span><span class="mi">1</span><span class="p">:]</span>
        <span class="k">return</span> <span class="nb">str</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">n</span><span class="p">))</span> <span class="o">+</span> <span class="s2">&quot;p&quot;</span> <span class="o">+</span> <span class="n">str_dec</span></div>


<div class="viewcode-block" id="GeneralUtils.str_y">
<a class="viewcode-back" href="../../gwmat.html#gwmat.general_utils.GeneralUtils.str_y">[docs]</a>
    <span class="k">def</span> <span class="nf">str_y</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">n</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns string version for a number</span>
<span class="sd">        up to two decimal places.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">str_float</span><span class="p">(</span><span class="n">n</span><span class="p">,</span> <span class="mi">2</span><span class="p">)</span></div>


<div class="viewcode-block" id="GeneralUtils.str_m">
<a class="viewcode-back" href="../../gwmat.html#gwmat.general_utils.GeneralUtils.str_m">[docs]</a>
    <span class="k">def</span> <span class="nf">str_m</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">n</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns string version for a number</span>
<span class="sd">        up to one decimal place.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">str_float</span><span class="p">(</span><span class="n">n</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span></div>


<div class="viewcode-block" id="GeneralUtils.str_to_float">
<a class="viewcode-back" href="../../gwmat.html#gwmat.general_utils.GeneralUtils.str_to_float">[docs]</a>
    <span class="k">def</span> <span class="nf">str_to_float</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">sf</span><span class="p">,</span> <span class="n">separater</span><span class="o">=</span><span class="s2">&quot;p&quot;</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        This function takes a string representation of a number where the decimal point</span>
<span class="sd">        is denoted by a specified separator (default is &#39;p&#39;) and converts it into a float.</span>
<span class="sd">        It replaces the separator with a dot (&#39;.&#39;) to ensure proper float conversion.</span>

<span class="sd">        Examples</span>
<span class="sd">        --------</span>
<span class="sd">        &gt;&gt;&gt; str_to_float(&quot;123p45&quot;)</span>
<span class="sd">        123.45</span>
<span class="sd">        &gt;&gt;&gt; str_to_float(&quot;678p90&quot;, separator=&quot;p&quot;)</span>
<span class="sd">        678.90</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="nb">float</span><span class="p">(</span><span class="n">sf</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="n">separater</span><span class="p">,</span> <span class="s2">&quot;.&quot;</span><span class="p">))</span></div>


<div class="viewcode-block" id="GeneralUtils.sync_keys_in_dict">
<a class="viewcode-back" href="../../gwmat.html#gwmat.general_utils.GeneralUtils.sync_keys_in_dict">[docs]</a>
    <span class="k">def</span> <span class="nf">sync_keys_in_dict</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key1</span><span class="p">,</span> <span class="n">key2</span><span class="p">,</span> <span class="n">default</span><span class="p">,</span> <span class="o">**</span><span class="n">dictionary</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Ensures that both key1 and key2 in the dictionary have the same value.</span>

<span class="sd">        If either of the keys is present, assign the same value to the other key.</span>
<span class="sd">        If both keys are present, check if their values are the same.</span>
<span class="sd">        If neither key is present, set it to default value.</span>

<span class="sd">        Parameters:</span>
<span class="sd">        - key1: First key to check.</span>
<span class="sd">        - key2: Second key to check.</span>
<span class="sd">        - dictionary: The dictionary in which the keys are checked.</span>

<span class="sd">        Returns:</span>
<span class="sd">        - modified dictionary.</span>

<span class="sd">        Raises:</span>
<span class="sd">        - KeyError: If neither key is found in the dictionary.</span>
<span class="sd">        - ValueError: If both keys are present but their values are different.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">val1</span> <span class="o">=</span> <span class="n">dictionary</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">key1</span><span class="p">)</span>
        <span class="n">val2</span> <span class="o">=</span> <span class="n">dictionary</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">key2</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">val1</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">val2</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">val1</span> <span class="o">!=</span> <span class="n">val2</span><span class="p">:</span>
                <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span>
                    <span class="sa">f</span><span class="s2">&quot;Values for `</span><span class="si">{</span><span class="n">key1</span><span class="si">}</span><span class="s2">` and `</span><span class="si">{</span><span class="n">key2</span><span class="si">}</span><span class="s2">` do not match.</span><span class="se">\</span>
<span class="s2"> Provide only one of the keys, not both.&quot;</span>
                <span class="p">)</span>
        <span class="k">elif</span> <span class="n">val1</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">dictionary</span><span class="p">[</span><span class="n">key2</span><span class="p">]</span> <span class="o">=</span> <span class="n">val1</span>
        <span class="k">elif</span> <span class="n">val2</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">dictionary</span><span class="p">[</span><span class="n">key1</span><span class="p">]</span> <span class="o">=</span> <span class="n">val2</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span>
                <span class="sa">f</span><span class="s2">&quot;Neither `</span><span class="si">{</span><span class="n">key1</span><span class="si">}</span><span class="s2">` nor `</span><span class="si">{</span><span class="n">key2</span><span class="si">}</span><span class="s2">` found in dictionary.</span><span class="se">\</span>
<span class="s2"> Setting it to `</span><span class="si">{</span><span class="n">default</span><span class="si">}</span><span class="s2">` by default.&quot;</span>
            <span class="p">)</span>
            <span class="n">dictionary</span><span class="p">[</span><span class="n">key1</span><span class="p">]</span> <span class="o">=</span> <span class="n">dictionary</span><span class="p">[</span><span class="n">key2</span><span class="p">]</span> <span class="o">=</span> <span class="n">default</span>

        <span class="k">return</span> <span class="n">dictionary</span></div>


<div class="viewcode-block" id="GeneralUtils.check_if_dict_is_subset">
<a class="viewcode-back" href="../../gwmat.html#gwmat.general_utils.GeneralUtils.check_if_dict_is_subset">[docs]</a>
    <span class="k">def</span> <span class="nf">check_if_dict_is_subset</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dict_1</span><span class="p">,</span> <span class="n">dict_2</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Check if one dictionary is a subset of another.</span>

<span class="sd">        This function checks whether all key-value pairs in the smaller dictionary</span>
<span class="sd">        exist in the larger dictionary. It does not check for strict subset relationships</span>
<span class="sd">        but ensures that the smaller dict&#39;s entries match those in the larger one.</span>

<span class="sd">        Parameters:</span>
<span class="sd">        - dict_1 (dict): First dictionary to compare.</span>
<span class="sd">        - dict_2 (dict): Second dictionary to compare.</span>

<span class="sd">        Returns:</span>
<span class="sd">          bool: True if all key-value pairs in the smaller dictionary are in the larger dictionary, </span>
<span class="sd">          False otherwise.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># Identify the smaller and larger dictionaries</span>
        <span class="n">smaller_dict</span><span class="p">,</span> <span class="n">larger_dict</span> <span class="o">=</span> <span class="p">(</span>
            <span class="p">(</span><span class="n">dict_1</span><span class="p">,</span> <span class="n">dict_2</span><span class="p">)</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">dict_1</span><span class="p">)</span> <span class="o">&lt;=</span> <span class="nb">len</span><span class="p">(</span><span class="n">dict_2</span><span class="p">)</span> <span class="k">else</span> <span class="p">(</span><span class="n">dict_2</span><span class="p">,</span> <span class="n">dict_1</span><span class="p">)</span>
        <span class="p">)</span>

        <span class="c1"># Check if all key-value pairs in the smaller dictionary are in the larger dictionary</span>
        <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">smaller_dict</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="n">larger_dict</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">key</span><span class="p">)</span> <span class="o">!=</span> <span class="n">value</span><span class="p">:</span>
                <span class="k">return</span> <span class="kc">False</span>

        <span class="k">return</span> <span class="kc">True</span></div>
</div>

</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Anuj Mishra.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>